#include "Rapid Screenshot.h"

HICON g_hIcon;
HWND g_hWndDialog;
HINSTANCE g_hInstance;

int APIENTRY  WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	g_hInstance = hInstance;
	g_hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1) );
	InitCommonControls();
	DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC)DialogProc);	
	DestroyIcon(g_hIcon);
	return 0;
}

INT_PTR CALLBACK DialogProc(HWND hwndDlg,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	
	switch (uMsg)
	{
		case WM_COMMAND:;
		if (HIWORD(wParam) == EN_CHANGE)
				UpdateCaptureButton();
		if (HIWORD(wParam) == BN_CLICKED)// On button click 
		{
			switch(LOWORD(wParam))
			{
			case IDC_OB_DESKTOP:
			case IDC_OB_WINDOW:
			case IDC_OB_PORTION:
				if (IsDlgButtonChecked(hwndDlg,IDC_OB_PORTION) == BST_CHECKED)
					EnablePortionControls(TRUE);
				else
					EnablePortionControls(FALSE);
				break;
			case IDC_CHK_AUTO:
				if (IsDlgButtonChecked(hwndDlg,IDC_CHK_AUTO) == BST_CHECKED)
					EnableAutoSave(TRUE);
				else
					EnableAutoSave(FALSE);
				UpdateCaptureButton();
				break;
			case IDC_BTN_CAPTURE:
				On_CaptureButton();
				UpdateCaptureButton();
				break;
			case IDC_BTN_FOLDER:
				GetFolderPath(hwndDlg,GetDlgItem(hwndDlg,IDC_EB_FOLDER));
				UpdateCaptureButton();
				break;
			case IDC_BTN_FILE:
				 GetBmpFilePath(hwndDlg,GetDlgItem(hwndDlg,IDC_EB_FILE));
				 UpdateCaptureButton();
				 break;	
			case IDC_BTN_ABOUT:
				DialogBox(g_hInstance,MAKEINTRESOURCE(IDD_ABOUT),hwndDlg,(DLGPROC)AboutDlgProc);
				break;
			}
		}
		break;
	case WM_INITDIALOG:
			g_hWndDialog = hwndDlg;
			EnableAutoSave(TRUE);
			SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_hIcon);
			CheckDlgButton(hwndDlg,IDC_CHK_HIDE,BST_CHECKED);
			CheckDlgButton(hwndDlg,IDC_CHK_AUTO,BST_CHECKED);
			CheckDlgButton(hwndDlg,IDC_OB_WINDOW,BST_CHECKED);
			EnablePortionControls(FALSE);
			LoadWorkingFolder();
			UpdateCaptureButton();
			return TRUE;
	case WM_CLOSE:
			SaveWorkingFolder();
			EndDialog(hwndDlg,0);
			break;
	}

	return FALSE;
}
INT_PTR CALLBACK AboutDlgProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	switch (uMsg)
	{
	case WM_COMMAND:
		if ( wParam == IDC_CMD_OK)
			EndDialog(hwndDlg,0);
			break;
	case WM_INITDIALOG:
		SendMessage(hwndDlg,WM_SETICON,ICON_BIG,(LPARAM)g_hIcon);
		return true;
	case WM_CLOSE:
		EndDialog(hwndDlg,0);
		break;
	}
	return FALSE;
}
void On_CaptureButton(void)
{
	BOOL bRet;
	HDC hdc;
	char szFilePath[MAX_PATH];

	if (GetFilePath(szFilePath) == FALSE)
	{
		MessageBox(g_hWndDialog,"File Path is not valid.","Rapid Screenshot Error",MB_OK | MB_ICONSTOP);
		return;
	}
		 
	hdc = CreateDC("DISPLAY", NULL, NULL, NULL);
	if( hdc == NULL )
	{
		MessageBox(g_hWndDialog,"Unable to get screen device context.","Rapid Screenshot Error",MB_OK | MB_ICONSTOP);
		return;
	}
	// ...
	int		x = 0,y = 0;
	int dwWidth, dwHeight;
	dwWidth = GetDeviceCaps(hdc, HORZRES);
	dwHeight = GetDeviceCaps(hdc, VERTRES);

	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_DESKTOP) == BST_CHECKED)
	{
	ShowDialog(SW_HIDE);
	bRet = Hdc2BmpFile(hdc,szFilePath,dwHeight,dwWidth,0,0);
	ShowDialog(SW_SHOW);
		if (bRet)
			return;
	}

	int iHeight = 0,iWidth = 0;

	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_WINDOW) == BST_CHECKED)
	{
		RECT rc;
		
		ShowDialog(SW_HIDE);
		GetWindowRect(GetForegroundWindow(),&rc);
		x = rc.left;
		y = rc.top ;
		iWidth =  rc.right - rc.left;
		iHeight = rc.bottom - rc.top;

		if ( dwWidth < x + iWidth)
				iWidth = dwWidth - x;
		if ( dwHeight < y + iHeight)
				iHeight = dwHeight - y;

		bRet = Hdc2BmpFile(hdc,szFilePath,iHeight,iWidth ,x,y);
		ShowDialog(SW_SHOW);
		if (bRet)
			return;			
	}

	if (IsDlgButtonChecked(g_hWndDialog,IDC_OB_PORTION) == BST_CHECKED)
	{
		char szSize[8];

		if (GetDlgItemText(g_hWndDialog,IDC_EB_X,szSize,sizeof(szSize)) > 0)
				x = atoi(szSize);		
		if (GetDlgItemText(g_hWndDialog,IDC_EB_Y,szSize,sizeof(szSize)) > 0)
				y = atoi(szSize);
		
		if (GetDlgItemText(g_hWndDialog,IDC_EB_HEIGHT,szSize,sizeof(szSize)) > 0)
				iHeight = atoi(szSize);
		if (GetDlgItemText(g_hWndDialog,IDC_EB_WIDTH,szSize,sizeof(szSize)) > 0)
				iWidth = atoi(szSize);
		//---->
		if ( iHeight == 0 || iWidth == 0 || iHeight + y > dwHeight || iWidth + x > dwWidth)
		{
			MessageBox(g_hWndDialog,"Please enter valid values in portion options.","Rapid Screenshot Error",MB_OK | MB_ICONSTOP);
			return;
		}
	
	ShowDialog(SW_HIDE);
	bRet = Hdc2BmpFile(hdc,szFilePath,iHeight,iWidth,x,y);
	ShowDialog(SW_SHOW);
		if (bRet)
			return;	
	}
MessageBox(g_hWndDialog,"Unable to Capture Screen Shot.","Rapid Screenshot Error",MB_OK | MB_ICONSTOP);
}
BOOL GetFilePath(LPSTR lpBuffer)
{
	char szPath[MAX_PATH];
	char szFileName[16];

	if (IsDlgButtonChecked(g_hWndDialog,IDC_CHK_AUTO) == BST_CHECKED)
	{
		if ( GetDlgItemText(g_hWndDialog,IDC_EB_FOLDER,szPath,sizeof(szPath)) == NULL)
			return FALSE;
		if ( PathFileExists(szPath) == FALSE )
			return FALSE;

		for (unsigned int i = 1;i < 0xffff;i++)
		{
			wsprintf(szFileName,"RS%u.bmp",i);
			PathCombine(lpBuffer,szPath,szFileName);
			if ( PathFileExists(lpBuffer)  == FALSE)
				 return TRUE;
		}
	}
	else
	{
		if ( GetDlgItemText(g_hWndDialog,IDC_EB_FILE,szPath,sizeof(szPath)) == NULL)
			return FALSE;
		if ( PathFileExists(szPath))
			return FALSE;

		lstrcpy(lpBuffer,szPath);
		return TRUE;
	}
	return FALSE;
}
void ShowDialog(int nCmdShow)
{
	if (IsDlgButtonChecked(g_hWndDialog,IDC_CHK_HIDE) == BST_CHECKED)
	{
		ShowWindow(g_hWndDialog,nCmdShow);
		if ( nCmdShow == SW_HIDE )
				Sleep(150);
	}

}
void EnableAutoSave(BOOL bEnable)
{
	if (bEnable)
	{
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_EB_FOLDER),TRUE);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_FOLDER),TRUE);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_LBL_FOLDER),TRUE);

		EnableWindow(GetDlgItem(g_hWndDialog,IDC_EB_FILE),FALSE);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_FILE),FALSE);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_LBL_FILE),FALSE);

	}
	else
	{
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_EB_FOLDER),FALSE);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_FOLDER),FALSE);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_LBL_FOLDER),FALSE);

		EnableWindow(GetDlgItem(g_hWndDialog,IDC_EB_FILE),TRUE);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_FILE),TRUE);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_LBL_FILE),TRUE);
	}
}
void EnablePortionControls(BOOL bEnable)
{
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_EB_X),bEnable);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_EB_Y),bEnable);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_EB_HEIGHT),bEnable);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_EB_WIDTH),bEnable);

		EnableWindow(GetDlgItem(g_hWndDialog,IDC_LBL_X),bEnable);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_LBL_Y),bEnable);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_LBL_HEIGHT),bEnable);
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_LBL_WIDTH),bEnable);

		EnableWindow(GetDlgItem(g_hWndDialog,IDC_GB_PORTION),bEnable);
}
void UpdateCaptureButton(void)
{
	char szPath[MAX_PATH];

	if (IsDlgButtonChecked(g_hWndDialog,IDC_CHK_AUTO) == BST_CHECKED)
	{
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_CAPTURE),TRUE);

		if ( GetDlgItemText(g_hWndDialog,IDC_EB_FOLDER,szPath,sizeof(szPath)) == NULL)
			EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_CAPTURE),FALSE);

		if ( PathFileExists(szPath) == FALSE )
			EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_CAPTURE),FALSE);

	}
	else
	{
		EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_CAPTURE),TRUE);

		if ( GetDlgItemText(g_hWndDialog,IDC_EB_FILE,szPath,sizeof(szPath)) == NULL)
			EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_CAPTURE),FALSE);

		if ( PathFileExists(szPath))
			EnableWindow(GetDlgItem(g_hWndDialog,IDC_BTN_CAPTURE),FALSE);

	}
}
void SaveWorkingFolder(void)
{
	char szFolderPath[MAX_PATH];
	HKEY keyHandle;
	DWORD disposition;

	ZeroMemory(szFolderPath,sizeof(szFolderPath));
	if ( GetDlgItemText(g_hWndDialog,IDC_EB_FOLDER,szFolderPath,sizeof(szFolderPath)) < 1)
		return;
	if ( PathFileExists(szFolderPath) == FALSE )
		return ;

	RegCreateKeyEx(HKEY_CURRENT_USER,
    "Software\\Arshad Latti\\Rapid Screenshot",0, 
	NULL, REG_OPTION_NON_VOLATILE,KEY_ALL_ACCESS,
	NULL, &keyHandle,&disposition);

	RegSetValueEx(keyHandle, "Working Folder",
    0, REG_BINARY, (CONST BYTE *) szFolderPath,
    sizeof(szFolderPath));

	RegCloseKey(keyHandle);
}

void LoadWorkingFolder(void)
{
	 char szFolderPath[MAX_PATH];
	 HKEY keyHandle;
	 DWORD disposition;

	RegCreateKeyEx(HKEY_CURRENT_USER,
    "Software\\Arshad Latti\\Rapid Screenshot",
    0, NULL, REG_OPTION_NON_VOLATILE,
    KEY_ALL_ACCESS, NULL, &keyHandle,&disposition);

	ZeroMemory(szFolderPath,sizeof(szFolderPath));
	if ( disposition==REG_OPENED_EXISTING_KEY)
	{
		disposition=sizeof(szFolderPath);


		RegQueryValueEx(keyHandle,"Working Folder",NULL, 
			NULL,(BYTE *)szFolderPath,&disposition);
	}

	RegCloseKey(keyHandle);
	if ( PathFileExists(szFolderPath)){
		SetDlgItemText(g_hWndDialog,IDC_EB_FOLDER,szFolderPath);
	}
	else{
		if (SHGetSpecialFolderPath(NULL,szFolderPath,CSIDL_MYPICTURES,FALSE))
			SetDlgItemText(g_hWndDialog,IDC_EB_FOLDER,szFolderPath);
	}
}

/*
This software created by Muhammad Arshad Latti
From Sargodha ( Pakistan) 
e-mail   :: arshadlatti@gmail.com 
web_site :: http://www.geocities.com/arshadlati
*/
